%bcond_with docs

Summary:        Deep Difference and search of any Python object/data
Name:           python-deepdiff
Version:        6.3.1
Release:    1%{?dist}

License:        MIT
URL:            https://github.com/seperman/deepdiff/
Source0:         %{url}/archive/%{version}/%{name}-v%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  make
BuildRequires:  python3-devel

BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(numpy)
BuildRequires:  python3dist(tomli-w)
BuildRequires:  python3dist(python-dateutil)
BuildRequires:  python3dist(jsonpickle)
BuildRequires:  python3dist(pydantic)

%if %{with docs}
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3-dotenv
BuildRequires:  python3-sphinx-sitemap
%endif

%global _description %{expand:
Deep Difference of dictionaries, iterables, strings, and ANY other object.
Includes additional modules with related functionality:
DeepSearch: Search for objects within other objects.
DeepHash: Hash any object based on their content.
Delta: Store the difference of objects and apply them to other objects.
Extract: Extract an item from a nested Python object using its path.
commandline: Use DeepDiff from commandline.}

%description %{_description}

%package     -n python3-deepdiff
Summary:        %{summary}
Recommends:     python3-deepdiff+cli

%description -n python3-deepdiff %{_description}


%package -n python3-deepdiff+cli
Summary: Subpackage for python3-deepdiff with extra cli dependencies
Requires: python3-deepdiff

%description -n python3-deepdiff+cli
This is the subpackage for python3-deepdiff with extra cli dependencies.

%files -n python3-deepdiff+cli -f %{_pyproject_ghost_distinfo}

%{_bindir}/deep


%prep
%autosetup -n deepdiff-%{version} -p1

find deepdiff/ -name \*.py -exec sed -i '/#!\/usr\/bin\/env /d' {} \;

sed -i 's/==/~=/' requirements*.txt


%generate_buildrequires
%pyproject_buildrequires -x cli,optimize


%build
%pyproject_wheel

%if %{with docs}
make -C docs html
rm -rf docs/_build/html/.{doctrees,buildinfo}
%endif


%install
%pyproject_install

%pyproject_save_files deepdiff


%check
%pytest tests/


%files -n python3-deepdiff -f %{pyproject_files}

%doc AUTHORS.md README.md

%if %{with docs}
%doc docs/_build/html
%endif



%changelog
* Wed Aug 21 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.3.1-1
- initial build
